var w = 800;
var h = 500;

var svg = d3
  .selectAll('#chart')
  //.selectAll("svg")
  .append('svg')
  .attr('width', w)
  .attr('height', h)
  .attr('class', 'svg');

var nameArray = [
    {"name":"L.I Brezhnev","born":"1906-12-19","died":"1982-11-10","startTime":"1956-02-27","endTime":"1982-11-10","exitType":"Death","exitFate":"Dead","job":"Metallurgical engineer","race":"Russian","leader":"Brezhnev"},
    {"name":"N.V Podgorny","born":"1903-02-18","died":"1983-01-12","startTime":"1958-06-18","endTime":"1977-05-24","exitType":"Resignation","exitFate":"No Punishment","job":"Engineer","race":"Ukrainian","leader":"Brezhnev"},
    {"name":"P.Y Shelest","born":"1908-02-14","died":"1996-01-22","startTime":"1963-12-13","endTime":"1973-04-27","exitType":"Resignation","exitFate":"No Punishment","job":"Metallurgical engineer","race":"Ukrainian","leader":"Brezhnev"},
    {"name":"P.N Demichev","born":"1917-12-21","died":"2010-08-10","startTime":"1964-11-16","endTime":"1988-09-30","exitType":"Resignation","exitFate":"No Punishment","job":"Mechanican engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"V.V Shcherbitsky","born":"1918-02-17","died":"1990-02-16","startTime":"1965-12-06","endTime":"1989-09-20","exitType":"Resignation","exitFate":"No Punishment","job":"Chemical engineer","race":"Ukrainian","leader":"Gorbachev"},
    {"name":"G.V Romanov","born":"1923-02-07","died":"2008-06-03","startTime":"1973-04-27","endTime":"1985-07-01","exitType":"Resignation","exitFate":"No Punishment","job":"Shipbuilding engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"N.A Tikhonov","born":"1905-05-14","died":"1997-06-01","startTime":"1978-11-27","endTime":"1986-03-06","exitType":"Resignation","exitFate":"No Punishment","job":"Technical engineer","race":"Russian/Ukrainian","leader":"Gorbachev"},
    {"name":"V.I Dolgikh","born":"1924-12-05","died":"NaT","startTime":"1982-05-24","endTime":"1988-09-30","exitType":"Resignation","exitFate":"No Punishment","job":"Engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"N.V Talyzin","born":"1929-01-28","died":"1991-01-23","startTime":"1985-10-15","endTime":"1989-09-20","exitType":"Resignation","exitFate":"No Punishment","job":"Engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"B.N Yeltsin","born":"1931-02-01","died":"2007-04-23","startTime":"1986-02-18","endTime":"1988-02-18","exitType":"Resignation","exitFate":"No Punishment","job":"Construction engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"Y.F Solovyev","born":"1925-08-20","died":"2011-10-02","startTime":"1986-03-06","endTime":"1989-09-20","exitType":"Resignation","exitFate":"No Punishment","job":"Construction engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"A.M Masaliev","born":"1933-04-10","died":"2004-07-31","startTime":"1990-07-14","endTime":"1991-04-25","exitType":"Resignation","exitFate":"No Punishment","job":"Mining engineer","race":"Kyrgyz","leader":"Gorbachev"},
    {"name":"M.G Pervukhin","born":"1904-10-14","died":"1978-07-22","startTime":"1957-06-29","endTime":"1961-10-17","exitType":"Demotion","exitFate":"No Punishment","job":"Electrical engineer","race":"Russian","leader":"Khrushchev"},
    {"name":"Y.K Ligachev","born":"1920-12-29","died":"NaT","startTime":"1985-04-23","endTime":"1990-07-14","exitType":"Demotion","exitFate":"No Punishment","job":"Engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"N.I Ryzhkov","born":"1929-09-28","died":"NaT","startTime":"1985-04-23","endTime":"1990-07-14","exitType":"Demotion","exitFate":"No Punishment","job":"Engineer","race":"Ukrainian","leader":"Gorbachev"},
    {"name":"Y.D Maslyukov","born":"1937-09-30","died":"2010-04-01","startTime":"1988-02-18","endTime":"1990-07-14","exitType":"Demotion","exitFate":"No Punishment","job":"Engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"A.V Vlasor","born":"1932-01-20","died":"2002-06-09","startTime":"1988-09-30","endTime":"1990-07-14","exitType":"Demotion","exitFate":"No Punishment","job":"Metallurgical engineer","race":"Russian","leader":"Gorbachev"},
    {"name":"V.A Ivashko","born":"1932-10-28","died":"1994-11-13","startTime":"1989-12-09","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Mining engineer","race":"Ukrainian","leader":null},
    {"name":"I.A Karimov","born":"1938-01-30","died":"2016-09-02","startTime":"1990-07-14","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Engineer","race":"Uzbek","leader":null},
    {"name":"K.M Makhkamov","born":"1932-04-16","died":"2016-06-08","startTime":"1990-07-14","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Mining engineer","race":"Tajik","leader":null},
    {"name":"A.N.O Mutalibov","born":"1938-05-12","died":"NaT","startTime":"1990-07-14","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Engineer","race":"Azeri","leader":null},
    {"name":"S.I Hurenko","born":"1936-05-30","died":"2013-04-14","startTime":"1990-07-14","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Process engineer","race":"Ukrainian","leader":null},
    {"name":"O.S Shenin","born":"1937-07-22","died":"2009-05-28","startTime":"1990-07-14","endTime":"1991-08-24","exitType":"Regime Change","exitFate":"USSR Ended","job":"Construction engineer","race":"Russian","leader":null},];

var dateFormat = d3.timeParse('%Y-%m-%d');

var timeScale = d3
  .scaleTime()
  .domain([
    d3.min(nameArray, function (d) {
      return dateFormat(d.startTime);
    }),
    d3.max(nameArray, function (d) {
      return dateFormat(d.endTime);
    }),
  ])
  .range([0, w - 150]);

var categories = new Array();

for (var i = 0; i < nameArray.length; i++) {
  categories.push(nameArray[i].exitType);
}

var catsUnfiltered = categories; //for vert labels

categories = checkUnique(categories);

makeGant(nameArray, w, h);

var title = svg
  .append('text')
  .text('Exit types of engineers in USSR')
  .attr('x', w / 2)
  .attr('y', 25)
  .attr('text-anchor', 'middle')
  .attr('font-size', 18)
  .attr('fill', '#009FFC');

function makeGant(names, pageWidth, pageHeight) {
  var topPadding = 75;
  var sidePadding = 75;
  var barHeight = (h - topPadding * 3) / nameArray.length;
  var gap = (h - topPadding * 2) / nameArray.length; //(barHeight + 4);

  var colorScale = d3
    .scaleLinear()
    .domain([0, categories.length])
    .range(['#00B9FA', '#F95002'])
    .interpolate(d3.interpolateHcl);

  makeGrid(sidePadding, topPadding, pageWidth, pageHeight);
  drawRects(
    names,
    gap,
    topPadding,
    sidePadding,
    barHeight,
    colorScale,
    pageWidth,
    pageHeight
  );
  vertLabels(
    gap,
    topPadding,
    sidePadding,
    barHeight,
    colorScale
  );
}

function drawRects(
  theArray,
  theGap,
  theTopPad,
  theSidePad,
  theBarHeight,
  theColorScale,
  w,
  h
) {
  var bigRects = svg
    .append('g')
    .selectAll('rect')
    .data(theArray)
    .enter()
    .append('rect')
    .attr('x', 0)
    .attr('y', function (d, i) {
      return i * theGap + theTopPad - 2;
    })
    .attr('width', function (d) {
      return w - theSidePad / 2;
    })
    .attr('height', theGap)
    .attr('stroke', 'none')
    .attr('fill', function (d) {
      for (var i = 0; i < categories.length; i++) {
        if (d.exitType == categories[i]) {
          return d3.rgb(theColorScale(i));
        }
      }
    })
    .attr('opacity', 0.2);

  var rectangles = svg
    .append('g')
    .selectAll('rect')
    .data(theArray)
    .enter();

  var innerRects = rectangles
    .append('rect')
    .attr('rx', 3)
    .attr('ry', 3)
    .attr('x', function (d) {
      return (
        timeScale(dateFormat(d.startTime)) + theSidePad
      );
    })
    .attr('y', function (d, i) {
      return i * theGap + theTopPad;
    })
    .attr('width', function (d) {
      return (
        timeScale(dateFormat(d.endTime)) -
        timeScale(dateFormat(d.startTime))
      );
    })
    .attr('height', theBarHeight)
    .attr('stroke', 'none')
    .attr('fill', function (d) {
      for (var i = 0; i < categories.length; i++) {
        if (d.exitType == categories[i]) {
          return d3.rgb(theColorScale(i));
        }
      }
    });

  var rectText = rectangles
    .append('text')
    .text(function (d) {
      return d.name;
    })
    .attr('x', function (d) {
      return (
        (timeScale(dateFormat(d.endTime)) -
          timeScale(dateFormat(d.startTime))) /
          2 +
        timeScale(dateFormat(d.startTime)) +
        theSidePad
      );
    })
    .attr('y', function (d, i) {
      return i * theGap + theBarHeight / 2 + theTopPad; //14+ theTopPad;
    })
    .attr('font-size', 11)
    .attr('text-anchor', 'middle')
    .attr('text-height', theBarHeight)
    .attr('fill', '#fff');

  rectText
    .on('mouseover', function (e) {
      // console.log(this.x.animVal.getItem(this));
      var tag = '';

      if (d3.select(this).data()[0].exitFate != undefined) {
        tag =
          'Name: ' +
          d3.select(this).data()[0].name +
          '<br/>' +
          'Exit Type: ' +
          d3.select(this).data()[0].exitType +
          '<br/>' +
          'Started: ' +
          d3.select(this).data()[0].startTime +
          '<br/>' +
          'Ended: ' +
          d3.select(this).data()[0].endTime +
          '<br/>' +
          'Exit Fate: ' +
          d3.select(this).data()[0].exitFate+
          '<br/>' +
          'Ethnicity: ' +
          d3.select(this).data()[0].race+
          '<br/>' +
          'Job: ' +
          d3.select(this).data()[0].job;
        
      } else {
        tag =
          'Name : ' +
          d3.select(this).data()[0].name +
          '<br/>' +
          'Exit Type: ' +
          d3.select(this).data()[0].exitType +
          '<br/>' +
          'Started: ' +
          d3.select(this).data()[0].startTime +
          '<br/>' +
          'Ended: ' +
          d3.select(this).data()[0].endTime +
          '<br/>' +
          'Exit Fate: ' +
          d3.select(this).data()[0].exitFate+
          '<br/>' +
          'Ethnicity: ' +
          d3.select(this).data()[0].race+
          '<br/>' +
          'Job: ' +
          d3.select(this).data()[0].job;
      }
      var output = document.getElementById('tag');

      var x = this.x.animVal.getItem(this) + 'px';
      var y = this.y.animVal.getItem(this) + 25 + 'px';

      output.innerHTML = tag;
      output.style.top = y;
      output.style.left = x;
      output.style.display = 'block';
    })
    .on('mouseout', function () {
      var output = document.getElementById('tag');
      output.style.display = 'none';
    });

  innerRects
    .on('mouseover', function (e) {
      //console.log(this);
      var tag = '';

      if (d3.select(this).data()[0].exitFate != undefined) {
        tag =
          'Name: ' +
          d3.select(this).data()[0].name +
          '<br/>' +
          'Exit Type: ' +
          d3.select(this).data()[0].exitType +
          '<br/>' +
          'Started: ' +
          d3.select(this).data()[0].startTime +
          '<br/>' +
          'Ended: ' +
          d3.select(this).data()[0].endTime +
          '<br/>' +
          'Exit Fate: ' +
          d3.select(this).data()[0].exitFate +
          '<br/>' +
          'Ethnicity: ' +
          d3.select(this).data()[0].race+
          '<br/>' +
          'Job: ' +
          d3.select(this).data()[0].job;
      } else {
        tag =
          'Name: ' +
          d3.select(this).data()[0].name +
          '<br/>' +
          'Exit Type: ' +
          d3.select(this).data()[0].exitType +
          '<br/>' +
          'Started: ' +
          d3.select(this).data()[0].startTime +
          '<br/>' +
          'Ended: ' +
          d3.select(this).data()[0].endTime +
          '<br/>' +
          'Exit Fate: ' +
          d3.select(this).data()[0].exitFate+
          '<br/>' +
          'Ethnicity: ' +
          d3.select(this).data()[0].race+
          '<br/>' +
          'Job: ' +
          d3.select(this).data()[0].job;
      }
      var output = document.getElementById('tag');

      var x =
        this.x.animVal.value +
        this.width.animVal.value / 2 +
        'px';
      var y = this.y.animVal.value + 25 + 'px';

      output.innerHTML = tag;
      output.style.top = y;
      output.style.left = x;
      output.style.display = 'block';
    })
    .on('mouseout', function () {
      var output = document.getElementById('tag');
      output.style.display = 'none';
    });
}

function makeGrid(theSidePad, theTopPad, w, h) {
  var xAxis = d3
    .axisBottom(timeScale)
    .ticks(d3.timeYear, 5)
    .tickSize(-h + theTopPad + 20, 0, 0)
    .tickFormat(d3.timeFormat('%Y'));

  var grid = svg
    .append('g')
    .attr('class', 'grid')
    .attr(
      'transform',
      'translate(' + theSidePad + ', ' + (h - 50) + ')'
    )
    .call(xAxis)
    .selectAll('text')
    .style('text-anchor', 'middle')
    .attr('fill', '#000')
    .attr('stroke', 'none')
    .attr('font-size', 10)
    .attr('dy', '1em');
}

function vertLabels(
  theGap,
  theTopPad,
  theSidePad,
  theBarHeight,
  theColorScale
) {
  var numOccurances = new Array();
  var prevGap = 0;

  for (var i = 0; i < categories.length; i++) {
    numOccurances[i] = [
      categories[i],
      getCount(categories[i], catsUnfiltered),
    ];
  }

  var axisText = svg
    .append('g') //without doing this, impossible to put grid lines behind text
    .selectAll('text')
    .data(numOccurances)
    .enter()
    .append('text')
    .text(function (d) {
      return d[0];
    })
    .attr('x', 10)
    .attr('y', function (d, i) {
      if (i > 0) {
        for (var j = 0; j < i; j++) {
          prevGap += numOccurances[i - 1][1];
          // console.log(prevGap);
          return (
            (d[1] * theGap) / 2 +
            prevGap * theGap +
            theTopPad
          );
        }
      } else {
        return (d[1] * theGap) / 2 + theTopPad;
      }
    })
    .attr('font-size', 11)
    .attr('text-anchor', 'start')
    .attr('text-height', 14)
    .attr('fill', function (d) {
      for (var i = 0; i < categories.length; i++) {
        if (d[0] == categories[i]) {
          //  console.log("true!");
          return d3.rgb(theColorScale(i)).darker();
        }
      }
    });
}

//from this stackexchange question: http://stackoverflow.com/questions/1890203/unique-for-arrays-in-javascript
function checkUnique(arr) {
  var hash = {},
    result = [];
  for (var i = 0, l = arr.length; i < l; ++i) {
    if (!hash.hasOwnProperty(arr[i])) {
      //it works with objects! in FF, at least
      hash[arr[i]] = true;
      result.push(arr[i]);
    }
  }
  return result;
}

//from this stackexchange question: http://stackoverflow.com/questions/14227981/count-how-many-strings-in-an-array-have-duplicates-in-the-same-array
function getCounts(arr) {
  var i = arr.length, // var to loop over
    obj = {}; // obj to store results
  while (i) obj[arr[--i]] = (obj[arr[i]] || 0) + 1; // count occurrences
  return obj;
}

// get specific from everything
function getCount(word, arr) {
  return getCounts(arr)[word] || 0;
}
